<template>
  <div class="gpa-search-user">
    <!-- No need for rui-form here -->
    <form action="#" @submit.prevent="search">
      <rui-field :label="$t(`activerecord.attributes.user.${searchField}`)"
                 :help="searchField === 'username' ? $t('js.users.search.username_help', { amount: minimumStringLength }) : null"
                 input-id="search_user_input"
                 invisible-label
                 inline>
        <input v-if="searchField === 'username'"
               id="search_user_input"
               v-model="inputValue"
               type="search"
               :name="name"
               :min="minimumStringLength"
               :placeholder="$t(`activerecord.attributes.user.username`)"
               @input="search"
               @focus="showResults = true">
        <input v-else
               id="search_user_input"
               v-model="inputValue"
               type="email"
               :placeholder="$t(`activerecord.attributes.user.email`)"
               @focus="toggleResults">
        <rui-button type="submit" :title="$t('generic.search')" :disabled="inputValue.length < minimumStringLength || loading" icon="magnifying-glass" />
      </rui-field>
    </form>
    <div v-if="showResults">
      <rui-loading v-if="loading" :text="$t('generic.loading')" centered class="-mvl" />
      <template v-else-if="results.length === 0 && inputValue.length >= minimumStringLength">
        <rui-empty icon-size="3" :content="noResultText" small />
        <rui-modal v-if="searchField === 'email'" :caption="noResultText" no-footer @close="clearResults">
          <gpa-user-invitation-form :show-success-notification="false"
                                    :email="inputValue"
                                    @cancel="clearResults"
                                    @invited="handleSelection" />
        </rui-modal>
      </template>

      <rui-list-item v-for="user in results"
                     :key="user.id"
                     :caption="user.username"
                     static>
        <template #right>
          <rui-button variant="creative" :disabled="ignoredIds.includes(user.id)" @click="handleSelection(user)">{{ $t('js.users.search.invite') }}</rui-button>
        </template>
      </rui-list-item>

      <rui-button class="-mtd" :caption="$t('js.users.search.hide')" block @click="showResults=false" />
    </div>
  </div>
</template>

<script>
import RuiButton from '@experiments-labs/rise_ui/src/components/Button/Button.vue'
import RuiEmpty from '@experiments-labs/rise_ui/src/components/DataDisplay/Empty/Empty.vue'
import RuiField from '@experiments-labs/rise_ui/src/components/Form/Field.vue'
import RuiListItem from '@experiments-labs/rise_ui/src/components/ListItem/ListItem.vue'
import RuiLoading from '@experiments-labs/rise_ui/src/components/Loading/Loading.vue'
import RuiModal from '@experiments-labs/rise_ui/src/components/Modal/Modal.vue'

import { randomString } from '@experiments-labs/rise_ui/src/lib/String.js'
import debounce from 'debounce'
import GpaUserInvitationForm from './_InvitationForm.vue'

export default {
  name: 'GpaSearchUsers',
  emits: [
    'choose',
  ],
  components: { RuiButton, RuiListItem, RuiModal, RuiEmpty, RuiLoading, RuiField, GpaUserInvitationForm },
  props: {
    ignoredIds: { required: false, type: Array, default: () => [] },
    searchField: { required: false, type: String, default: 'username', validator: s => /^(username|email)$/.test(s) },
  },
  data () {
    return {
      minimumStringLength: 3,
      showResults: false,
      id: `search_field_${randomString()}`,
      name: 'search_field',
      loading: false,
      results: [],
      inputValue: '',
      invitationError: null,
    }
  },
  computed: {
    noResultText () {
      if (this.results.length === 0) return this.$t('js.users.search.no-results')
      else return this.$t('js.users.search.no-results')
    },
  },
  methods: {
    clearResults () {
      this.showResults = false
      this.inputValue = ''
    },
    search () {
      if (this.searchField === 'email') this.searchByEmail()
      else this.searchByUserName()
    },
    searchByUserName: debounce(function () {
      if (this.inputValue.length < this.minimumStringLength) return

      this.loading = true
      this.showResults = true
      this.$store.dispatch('findUsers', { username: this.inputValue })
        .then((users) => { this.setResults(users) })
    }, 500),
    searchByEmail () {
      this.loading = true
      this.showResults = true

      this.$store.dispatch('findUsers', { email: this.inputValue })
        .then((users) => { this.setResults(users) })
    },
    setResults (users) {
      this.results = users
      this.loading = false
    },
    toggleResults () {
      if (this.searchField === 'username' || (this.searchField === 'email' && this.results.length > 0)) this.showResults = true
    },
    handleSelection (user) {
      this.$emit('choose', user)
      this.showResults = false
    },
  },
}
</script>
